<?php

/*
   File: generator.php
   The average time for generator to run is
   about 12 seconds. This file is spawened
   as a daemon from the nextbus.sh nohup'er.

   This file prepares the temp directory. It
   then grabs all the stops, and writes it to
   an output.

   It also does the same to lines.

   After finishing that, it spawns childs
   so that it can grab prediction times for
   every individual stop and line (runs all
   async'ed).

   0.1: changed so that agency is dynamic and
   must be passed through in the command line
*/
$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');
include_once($basedir . '/../include/xml2array.php');

$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';
//$agency = 'rutgers';
$agency = $argv[1]; // script now requires an input of agency

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

// generating the appropriate dirs
if ($agency == 'rutgers')
   if (!is_dir($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus'))
      mkdir($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus', 0755, TRUE) or die("Couldn't create " . $GLOBALS['CONFIG']['temp_dir'] . "/0.0/nextbus/");


if (!is_dir($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus'))
   mkdir($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus', 0755, TRUE) or die("Couldn't create " . $GLOBALS['CONFIG']['temp_dir'] . "/0.1/nextbus/");

if (!is_dir($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus/' . $agency))
   mkdir($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus/' . $agency, 0755, TRUE) or die("Couldnt create " . $GLOBALS['config']['temp_dir'] . "/0.1/nextbus/" . $agency);

// beginning script
$routes = file_get_contents($nextbus_url . '?a=' . $agency . '&command=routeConfig');
if ($routes === false) die();

$routes = xml2array($routes);
$routes = $routes['body']['route'];

$list = array();
$stops_list = array();

for($i = 0; $i < count($routes); $i++) 
{
   // attr => array(tag, title)
   // stop => # => attr => tag, title
   $list[$i]['route_name'] = $routes[$i]['attr']['title'];   
   $list[$i]['route_id'] = $routes[$i]['attr']['tag'];
  // $list[$i]['stops'] = count($routes[$i]['stops']);   
   for ($j = 0; $j < count($routes[$i]['stop']); $j++)
   {
      if (!isset($routes[$i]['stop'][$j]['attr']['stopId']))
         continue;

      $list[$i]['stops'][$j]['stop_name'] = $routes[$i]['stop'][$j]['attr']['title'];
      $list[$i]['stops'][$j]['stop_id'] = $routes[$i]['stop'][$j]['attr']['stopId'];
      array_push($stops_list, 
         array(
            "stop_name" => $list[$i]['stops'][$j]['stop_name'], 
            "stop_id" => $list[$i]['stops'][$j]['stop_id'], 
            "lat" => $routes[$i]['stop'][$j]['attr']['lat'], 
            "lon" => $routes[$i]['stop'][$j]['attr']['lon']
         )
      );
   }

}

// unique array of stops
$stops_output = array();
$ignore_list = array('1036');
foreach ($stops_list as $check_stop)
{
   $exists = false;
   foreach ($stops_output as $with_stop)
   {
      if ($with_stop['stop_id'] == $check_stop['stop_id'])
      {
         $exists = true;
         break;
      }
   }

   if (in_array($check_stop['stop_id'], $ignore_list))
   {
      $exists = true;
   }   

   if (!$exists)
      $stops_output[] = $check_stop;
}

//sorting
$stop_names = array();
$stop_ids = array();

foreach ($stops_output as $key => $row) {
    $stop_names[$key]  = $row['stop_name'];
    $stop_ids[$key] = $row['stop_id'];
}

array_multisort($stop_names, SORT_ASC, $stop_ids, SORT_ASC, $stops_output);

if ($agency == 'rutgers') // for the old 0.0 api compatability
{
   // list of stops
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/stops_list.txt', 'w');
   fwrite($file, json_encode($stops_output));
   fclose($file);

   // lines -> stops
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/route_config.txt', 'w');
   fwrite($file, json_encode($list));
   fclose($file);
}


// list of stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus/' . $agency . '/stops_list.txt', 'w');
fwrite($file, json_encode($stops_output));
fclose($file);

// lines -> stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus/' . $agency . '/route_config.txt', 'w');
fwrite($file, json_encode($list));
fclose($file);

// removing stops2db as it is not needed
//include('stops2db.php'); // this jsut adds all the stops in the db.

foreach ($list as $route)
{   
   exec('php ' . $basedir . '/line2stops-times.php ' . $agency . ' ' . $route['route_id'] . '  &');
}

foreach ($stops_output as $stop)
{
   exec('php ' . $basedir . '/stop2lines-times.php ' . $agency . ' ' . $stop['stop_id'] . '  &');
}
?>
