<?php

/*
   File: stop2lines-times.php
   This file is spawned by generator.php

   stop2lines looks at a given stop, takes the XML
   from NextBus, takes each "line" that a stop runs
   and prints it into pretty JSON.
*/

$agency = $argv[1];
$_GET['stop'] = $argv[2];

$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');
include_once($basedir . '/../include/xml2array.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';

// 1. We first need to grab the XML provided by NextBus
// then with this data, we parse it into an array.
$stop_data = file_get_contents($nextbus_url . '?a=' . $agency . '&command=predictions&stopId=' . $_GET['stop']);
if ($stop_data === false) die();
$stop_data = xml2array($stop_data);

$output = array();

$output['running'] = true;

// 2. We check to see if the body contains anything
// or if we have and predictive results in the body.
// if not, we assume that the given route is not running.
$not_running_count = 0;
if (!isset($stop_data['body']['predictions']) || $stop_data['body']['predictions'] == null || $stop_data['body'] == null)
{
   $output['running'] = false;
}
else
{
   foreach ($stop_data['body']['predictions'] as $check_stop)
   {
      if (isset($check_stop['attr']['dirTitleBecauseNoPredictions']))
         $not_running_count++;
   }

   if ($not_running_count == count($stop_data['body']['predictions']))
      $output['running'] = false;
}

// 3. As long as output->running is not set to false
// we can start using that data to parse.
// we take each and every line, and start putting
// it into an array along with its times.
if ($output['running'])
{
   // checking for available predictions
   if(!isset($stop_data['body']['predictions'][0]))
   {
      $temp = $stop_data['body']['predictions'];
      $stop_data['body']['predictions'] = null;
      $stop_data['body']['predictions'][0] = $temp;
   }

   // placing title into output
   $output['stop_name'] = $stop_data['body']['predictions'][0]['attr']['stopTitle'];

   $i = 0;
   foreach ($stop_data['body']['predictions'] as $line_data) //running for each line
//   for ($i = 0; $i < count($stop_data['body']['predictions']); $i++)
   {
      // placing line name into output
      $output['lines'][$i]['route_name'] = $line_data['attr']['routeTitle'];

      // checking if that line/route has a prediction
      if (isset($line_data['attr']['dirTitleBecauseNoPredictions'])
         || count($line_data['direction']['prediction']) == 0)
      {
         $output['lines'][$i]['predictions'] = null;
      } 
      else
      {
         // placing that line direction's title into output
         $output['lines'][$i]['direction'] = $line_data['direction']['attr']['title'];
      
         if (!isset($line_data['direction']['prediction'][0]))
         {
            $temp = $line_data['direction']['prediction'];
            $line_data['direction']['prediction'] = null;
            $line_data['direction']['prediction'][0] = $temp;
         }

         for($j = 0; $j < count($line_data['direction']['prediction']); $j++) //running for each prediction for line
            $output['lines'][$i]['predictions'][$j] = $line_data['direction']['prediction'][$j]['attr']['minutes'];    
      }

   $i++;
   
   }
}

$output['schema'] = "0.0/nextbus/stops.json";

if ($agency == 'rutgers') //0.0 specific
{
   // we are now writing to the file
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/nextbus/' . $_GET['stop'] . '.txt', 'w');
   fwrite($file, json_encode($output));
   fclose($file);
}

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.1/nextbus/' . $agency . '/' . $_GET['stop'] . '.txt', 'w');
fwrite($file, json_encode($output));
fclose($file);

?>
