<?php

/*
   File: shortcuts-generate.php
   This currently generates a JSON of shortcuts that are
   defined in an array. Hopefully, this will be run in database
   but for now this is ran statically and as a concept.
*/

$basedir = dirname(__FILE__);

include_once($basedir . '/include/config.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n"); 

function generate_shortcut($handle, $title, $url, $canDelete, $dashFirst, $dashSecond, $fontSize=null, $icon=null)
{
   ($handle && $title && $url && $canDelete && $dashSecond) or die("FATAL: " . __FILE__ . ":" . __LINE__ . ": shortcut arguments not present");
   $s = compact("handle", "title", "url", "canDelete", "dashFirst", "dashSecond", "fontSize", "icon");

   return $s;
}

function save_data($json)
{
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt', 'w');
   fwrite($file, $json);
   fclose($file);

   chmod($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt', 0644);
   rename($GLOBALS['CONFIG']['temp_dir'] . '/0.0/shortcuts.txt',$GLOBALS['CONFIG']['web_dir'] . '/0.0/shortcuts.txt');
}

$a = array();

# If a shortcut only has one line caption, use dashSecond only. So says rfranknj; blame him.
$a[] = generate_shortcut('sakai', 'Sakai', 'https://sakai.rutgers.edu/mobile', 'true', '', 'Sakai');
$a[] = generate_shortcut('stud_life', 'Student Life', 'http://getinvolved.rutgers.edu/m/', 'true', '', 'Student Life');
$a[] = generate_shortcut('campus_status', 'Emergency Alert', 'http://halflife.rutgers.edu/ec/notices.php', 'true', 'Emergency', 'Alert', 36, 'scarletemer5');
$a[] = generate_shortcut('myrutgers', 'myRutgers', 'https://my.rutgers.edu/', 'true', '', 'myRutgers');
$a[] = generate_shortcut('athletics', 'Athletics App', 'http://itunes.apple.com/WebObjects/MZStore.woa/wa/viewSoftware?id=458425730&mt=8&uo=6', true, '', 'Athletics App');
$a[] = generate_shortcut('ecollege', 'eCollege', 'https://ecollege.rutgers.edu/index2.jsp', true, '', 'eCollege');

// FIXME: what if the handle is duplicate? we should error out. eh, database will fix this in the CREATE TABLE, nevermind for now
// FIXME: what if json_encode fails? Eh, Nagios check should come up, I hope.

save_data(json_encode($a));
