<?php
/*
   File: status-scrape.php
   This file looks at HTML, takes it, scrapes it, then parses each
   seperate element into an array. It then does some langauge checks
   on the latest element to see if we can predict if the campus is
   closed or not. Note that it can be wrong.
*/
$basedir = dirname(__FILE__);

include_once($basedir . '/include/config.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n"); 
if (ini_get('date.timezone') == '') die ("FATAL: " . __FILE__ . ": requires that date.timezone has a value in php.ini\n");

$website = file_get_contents('http://halflife.rutgers.edu/ec/notices.php');

$split = preg_split('~(<body>)~', $website);
$split = preg_split('~(</body>)~', $split[1]);
$split = preg_split('~(<hr>)~', $split[0]);

//print_r($split);

$json_output = array();
foreach ($split as $segment)
{
   $matches = array();
   $date = array();
   $content = array();

//   echo $segment;

   preg_match('/<div class="title">(.*?)<\/div>/si', $segment, $title);
//   print_r($title);
//   echo $title[1];
   preg_match('/<div class="posted">(.*?)<\/div>/si', $segment, $date);
   if (!isset($date[1])) continue;
   preg_match('/\((.*?)\)/si', $date[1], $date);
//   echo $date[1];
   preg_match('/<div class="contents">(.*?)<\/div>/si', $segment, $content);
//   echo $content[1];

   if (isset($title[1]) && isset($date[1]) && isset($content[1]))
   {
      $scrape = array('title' => utf8_encode($title[1]), 'date' => utf8_encode(strip_tags($date[1])), 'content' => utf8_encode(strip_tags($content[1])));
      $json_output[] = $scrape;
   }
}

if (strtotime($json_output[0]['date']) > strtotime('today') && strtotime($json_output[0]['date']) < strtotime('tomorrow'))
{
   if (strpos($json_output[0]['content'], 'delayed'))
   {
      $status = "delayed";
   }
   else if (strpos($json_output[0]['content'], 'closed'))
   {
      $status = "closed";
   }
   else
   {
      $message = "message";
   }
}
else
{
   $status = "running";
}

$json_output = array('status' => $status, 'data' => $json_output);

//print_r($json_output);
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/0.0/status.txt', 'w');
fwrite($file, json_encode($json_output));
fclose($file);
chmod($GLOBALS['CONFIG']['temp_dir'] . '/0.0/status.txt', 0644);
rename($GLOBALS['CONFIG']['temp_dir'] . '/0.0/status.txt', $GLOBALS['CONFIG']['web_dir'] . '/0.0/status.txt');

//echo $split[0];
//echo $split[1];

//print_r($split);

?>
